﻿"uses strict";
var events = require('events');
var exec = require('child_process').exec;

var Logger = {

    DATALOGGER: function(){
        var rate = [100, 250, 500, 1000, 2000, 5000];
        var rateindex = 2;
        var dataloggerEvent = new events.EventEmitter();
        var timer = null;

        function ticks() {
            dataloggerEvent.emit("Datalogger.Ticks");
        }

        this.RateDown = function () {
            if (rateindex < rate.length - 1) {
                rateindex++;
                clearInterval(timer);
                timer = setInterval(ticks, rate[rateindex]);
                dataloggerEvent.emit("Datalogger.Rate", rate[rateindex] + " ms");
            }
        };

        this.RateUp = function () {
            if (rateindex > 0) {
                rateindex--;
                clearInterval(timer);
                timer = setInterval(ticks, rate[rateindex]);
                dataloggerEvent.emit("Datalogger.Rate", rate[rateindex] + " ms");
            }
        };

        this.Running = function () {
            if (timer !== null) {
                clearInterval(timer);
                timer = null;
                dataloggerEvent.emit("Datalogger.Rate", "On Pause");
            }
            else {
                timer = setInterval(ticks, rate[rateindex]);
                dataloggerEvent.emit("Datalogger.Rate", rate[rateindex] + " ms");
            }
        };

        this.RunStatut = function () {
            return timer !== null;
        }

        this.Event = dataloggerEvent;
        this.Rate = rate[rateindex] + " ms";
        timer = setInterval(ticks, rate[rateindex]);
    }
    ,

    BUFFER: function (buffersize) {

        var size = buffersize;
        var values = [];
        var bufEvent = new events.EventEmitter();
 
        this.Add = function (analog, input, output) {
            let tmp = [];           
            let bInp = [];
            let bOut = [];

            for (let i = 0; i < input.length; i++) {
                bInp.push(input[i] ? 0 : 1);
            }
            
            for (let i = 0; i < output.length; i++) {
                bOut.push(output[i] ? 0 : 1);              
            }
         
            values.push(new Date().valueOf() + ";" +
                tmp.concat(analog.join(";"),
                bInp.join(";"),
                bOut.join(";")).join(";"));

            if (values.length > size) { values.shift(); }
            this.Use = values.length;
            bufEvent.emit("Buffer.Update", size, this.Use);
        };

        this.Clear = function () {
            values.splice(0, values.length);
            bufEvent.emit("Buffer.Update", size, values.length);
        };

        this.CsvFileame = function () {
            let d = new Date();
            return d.toISOString().slice(0, 10).replace(/-/g, '') + "_" +
                d.toLocaleTimeString().replace(/:/g, '') + '.csv';
        };

        this.Csv = function () {
            let csv = [];
            csv.push("Timestamp;" +
                "An0; An2; An2; An3; An4; An5; An6; An7;" +
                "In0; In1;In2;In3;In4;In5;In6;In7;" +
                "Out0;Out1;Out2;Out3;Out4;Out5;Out6;Out7");
            return csv.concat(values).join("\r\n");
        };

        this.Size = size;
        this.Use;
        this.Event = bufEvent;
    }
    ,

    SYSTEM: function () {
      
        var sysEvent = new events.EventEmitter();

        function temperature() {
                exec('vcgencmd measure_temp', function (error, stdout, stderr) {
                    var str = `${stdout}`;
                    str = str.match(/[+-]?\d+(\.\d+)?/g).map(Number)[0];
                    sysEvent.emit("System.Message", "CPU Température : " + str + " °C");

                });
        };

        
        this.Reboot = function () {
            exec('shutdown -r 0');
        };

        this.Shutdown = function () {
            exec('shutdown -t 0');
        };

        this.Event = sysEvent;
        timerTemperature = setInterval(temperature, 5000);
    }

};
module.exports = Logger;