﻿"uses strict";
var Spi_IO = {

    MCP3208: function (rpio, cs, clk) {

        this.Cs = cs;
        this.Clk = clk;
        this.Resolution = 12;


        rpio.spiSetCSPolarity(cs, rpio.LOW); 

        var adcResult = function (reg) {
            rpio.spiTransfer(reg, reg, reg.length);
            return reg;
        };

        this.ReadAll = function () {
            rpio.spiSetClockDivider(this.Clk);
            rpio.spiChipSelect(this.Cs);
            var x = [];
            var b = [];
            for (i = 0; i < 8; i++) {
                b = adcResult(Buffer.from([(i >> 2) + 6, i << 6 & 0xFF, 0x00]));
                x[i] = ((b[1] & 0x0F) << 8) + b[2];
            }
            return x;
        };

        this.ReadChannel = function (channel) {
            rpio.spiSetClockDivider(this.Clk);
            rpio.spiChipSelect(this.Cs);
            var b = adcResult(Buffer.from([(channel >> 2) + 6, channel << 6 & 0xFF, 0x00]));
            return ((b[1] & 0x0F) << 8) + b[2];
        };
    }

    ,

    MCP23S17: function (rpio, cs, clk) {

        this.Cs = cs;
        this.Clk = clk;



        function init() {
            rpio.spiSetClockDivider(clk);
            rpio.spiChipSelect(cs);
            rpio.spiSetCSPolarity(cs, rpio.LOW);
            ioResult(Buffer.from([0x40, 0x0A, 0x08])); //IOCON : BANK 0, ADRESS ENABLE
            ioResult(Buffer.from([0x40, 0x00, 0xFF])); //Port A All Input 
            ioResult(Buffer.from([0x40, 0x0C, 0xFF])); //Port A All PullUp 
            ioResult(Buffer.from([0x40, 0x02, 0xFF])); //Port A reverse 
            ioResult(Buffer.from([0x40, 0x01, 0x00])); //Port B All Output
        }

        var ioResult = function (reg) {
            rpio.spiTransfer(reg, reg, reg.length);
            return reg[2];
        };

        this.ReadInput = function () {
            rpio.spiSetClockDivider(this.Clk);
            rpio.spiChipSelect(this.Cs);
            return ioResult(Buffer.from([0x41, 0x12, 0x00])); // Read port A
        };

        this.ReadOutput = function () {
            rpio.spiSetClockDivider(this.Clk);
            rpio.spiChipSelect(this.Cs);
            return ioResult(Buffer.from([0x41, 0x13, 0x00])); // Read port B
        };

        this.WriteOutput = function (output) {
            rpio.spiSetClockDivider(this.Clk);
            rpio.spiChipSelect(this.Cs);
            ioResult(Buffer.from([0x40, 0x13, output])); // Write port B
        };

        init();
    }
};

module.exports = Spi_IO;